Package net.sf.saxon.tree.iter

## Class SingletonIterator<T extends Item>

- java.lang.Object
- - net.sf.saxon.tree.iter.SingletonIterator<T>

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `SequenceIterator`, `GroundedIterator`, `LookaheadIterator`, `ReversibleIterator`, `UnfailingIterator`
  Direct Known Subclasses:
    `SingleAtomicIterator`

      public class SingletonIterator<T extends Item>
      extends java.lang.Object
      implements SequenceIterator, UnfailingIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator

  SingletonIterator: an iterator over a sequence of zero or one values

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SingletonIterator​(T value)` | Private constructor: external classes should use the factory method

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getLength()` | Get the last position (that is, the number of items in the sequence).
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `SingletonIterator<T>` | `getReverseIterator()` | Get a new SequenceIterator that returns the same items in reverse order.
    `T` | `getValue()` |
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `static <T extends Item> UnfailingIterator` | `makeIterator​(T item)` | Factory method.
    `GroundedValue` | `materialize()` | Return a Value containing all the items in the sequence returned by this SequenceIterator
    `T` | `next()` | Get the next item in the sequence.
    `static <T extends Item> SingletonIterator<T>` | `rawIterator​(T item)` | Factory method for use when it is known the item will not be null

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Constructor Detail

    - #### SingletonIterator

          public SingletonIterator​(T value)

      Private constructor: external classes should use the factory method
      Parameters:
        `value` - the item to iterate over

  - ### Method Detail

    - #### makeIterator

          public static <T extends Item> UnfailingIterator makeIterator​(T item)

      Factory method.
      Parameters:
        `item` - the item to iterate over
      Returns:
        a SingletonIterator over the supplied item, or an EmptyIterator if the supplied item is null.

    - #### rawIterator

          public static <T extends Item> SingletonIterator<T> rawIterator​(T item)

      Factory method for use when it is known the item will not be null
      Parameters:
        `item` - the item to iterate over; must not be null
      Returns:
        a SingletonIterator over the supplied item

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.
      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items

    - #### next

          public T next()

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.

    - #### getLength

          public int getLength()

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence

    - #### getReverseIterator

          public SingletonIterator<T> getReverseIterator()

      Description copied from interface: `ReversibleIterator`
      Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator`
      Returns:
        an iterator over the items in reverse order

    - #### getValue

          public T getValue()

    - #### materialize

          public GroundedValue materialize()

      Return a Value containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding Value. If the value is a closure or a function call package, it will be evaluated and expanded.

    - #### getResidue

          public GroundedValue getResidue()

      Description copied from interface: `GroundedIterator`
      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure. This method does not change the state of the iterator (in particular, it does not consume the iterator).
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.